### Virtual Method

# Gio File set_attribute

#### Declaration

    gboolean
    set_attribute (
      GFile* file,
      const char* attribute,
      GFileAttributeType type,
      gpointer value_p,
      GFileQueryInfoFlags flags,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Sets an attribute in the file with attribute name `attribute` to `value_p`.

Some attributes can be unset by setting `type` to `G_FILE_ATTRIBUTE_TYPE_INVALID` and `value_p` to `NULL`.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

#### Parameters

`attribute`

  Type: `const char*`

  A string containing the attribute’s name.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`type`

  Type: `GFileAttributeType`

  The type of the attribute.

`value_p`

  Type: `gpointer`

  A pointer to the value (or the pointer itself if the type is a pointer type).

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`flags`

  Type: `GFileQueryInfoFlags`

  A set of `GFileQueryInfoFlags`.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if the attribute was set, `FALSE` otherwise.